#ifndef _ASMARM_KERNEXEC_H
#define _ASMARM_KERNEXEC_H

#ifndef __ASSEMBLY__

#include <linux/preempt.h>
#include <linux/thread_info.h>
#include <asm/domain.h>

#if defined(CONFIG_PAX_KERNEXEC) || defined(CONFIG_PAX_MEMORY_UDEREF)
static inline int test_domain(int domain, int domaintype)
{
	return ((current_thread_info()->cpu_domain) & domain_val(domain, 3)) == domain_val(domain, domaintype);
}
#endif

#define  __HAVE_ARCH_PAX_OPEN_KERNEL
#define  __HAVE_ARCH_PAX_CLOSE_KERNEL
#include <asm-generic/kernexec.h>

#if defined(CONFIG_MMU) && defined(CONFIG_PAX_KERNEXEC)
static inline unsigned long pax_open_kernel(void) {
#ifdef CONFIG_ARM_LPAE
	/* TODO */
#else
	preempt_disable();
	BUG_ON(test_domain(DOMAIN_KERNEL, DOMAIN_KERNEXEC));
	modify_domain(DOMAIN_KERNEL, DOMAIN_KERNEXEC);
#endif
	return 0;
}

static inline unsigned long pax_close_kernel(void) {
#ifdef CONFIG_ARM_LPAE
	/* TODO */
#else
	BUG_ON(test_domain(DOMAIN_KERNEL, DOMAIN_MANAGER));
	/* DOMAIN_MANAGER = "client" under KERNEXEC */
	modify_domain(DOMAIN_KERNEL, DOMAIN_MANAGER);
	preempt_enable_no_resched();
#endif
	return 0;
}
#else /* !CONFIG_MMU || !CONFIG_PAX_KERNEXEC */
static inline unsigned long pax_open_kernel(void) { return 0; }
static inline unsigned long pax_close_kernel(void) { return 0; }
#endif /* CONFIG_MMU */

#endif /* __ASSEMBLY__ */

#endif /* _ASMARM_KERNEXEC_H */
