/*
 * Kernel constants to make available for plugins without the need to include
 * kernel headers.
 *
 * There's overlap with asm-offsets.h, but we want enums, not defines to have
 * compiler visible symbolic values.
 *
 * This file's assembler source will be post-processed to generate "ksyms.h"
 *
 * Written by Mathias Krause <minipli@grsecurity.net>
 * Copyright 2020 by Open Source Security, Inc.
 * Licensed under the GPL v2
 */

#define KSYMS_GENERATE_INCLUDES
#include "ksyms.def"
#include <linux/kbuild.h> /* need to be last! */

void __nostackprotector kernel_symbols(void) {
	/* These symbols will be generated as expanded enums 'sym = val' */
#define KSYMS_GENERATE_DEFINES
#include "ksyms.def"
}
